/*
 * 商学院每日晨会
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class SchoolMorningMeetController : BaseController
    {
        public SchoolMorningMeetController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商学院每日晨会列表

        /// <summary>
        /// 根据条件查询商学院每日晨会列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(SchoolMorningMeet data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询商学院每日晨会列表

        /// <summary>
        /// 商学院每日晨会列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(SchoolMorningMeet data, string IsBannerSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Title", "1"); //标题
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("Lecturer", "1"); //主讲


            string condition = " and Status>-1";
            if (!string.IsNullOrEmpty(IsBannerSelect))
            {
                condition += " and IsBanner=" + IsBannerSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolMorningMeet", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";
                dic["IsBannerName"] = dic["IsBanner"].ToString() == "1" ? "是" : "否";

            }
            return Json(obj);
        }

        #endregion

        #region 增加商学院每日晨会

        /// <summary>
        /// 增加或修改商学院每日晨会信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加商学院每日晨会

        /// <summary>
        /// 增加或修改商学院每日晨会信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(SchoolMorningMeet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Title", data.Title); //标题
            Fields.Add("Lecturer", data.Lecturer); //主讲
            Fields.Add("Photo", data.Photo); //照片
            Fields.Add("StudyPerson", data.StudyPerson); //学习人数
            Fields.Add("Url", data.Url); //外链
            Fields.Add("Contents", data.Contents); //内容

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            Fields.Add("IsBanner", data.IsBanner); //首页每日晨会推荐
            Fields.Add("BannerPhoto", data.BannerPhoto); //每日晨会Banner
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("SchoolMorningMeet", Fields, 0);
            AddSysLog(data.Id.ToString(), "SchoolMorningMeet", "add");
            db.SaveChanges();
            var info = db.SchoolMorningMeet.FirstOrDefault(m => m.Id == Id);
            if (info != null)
            {
                info.Sort = function.ConvertDateTimeInt(data.CreateDate.Value) / 60;
                info.QueryCount = function.ConvertDateTimeInt(data.UpdateDate.Value) / 60;
                db.SaveChanges();
            }

            return "success";
        }

        #endregion

        #region 修改商学院每日晨会

        /// <summary>
        /// 增加或修改商学院每日晨会信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            SchoolMorningMeet editData = db.SchoolMorningMeet.FirstOrDefault(m => m.Id == Id) ?? new SchoolMorningMeet();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商学院每日晨会

        /// <summary>
        /// 增加或修改商学院每日晨会信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(SchoolMorningMeet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Title", data.Title); //标题
            Fields.Add("Lecturer", data.Lecturer); //主讲
            Fields.Add("Photo", data.Photo); //照片
            Fields.Add("StudyPerson", data.StudyPerson); //学习人数
            Fields.Add("Url", data.Url); //外链
            Fields.Add("Contents", data.Contents); //内容

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            Fields.Add("IsBanner", data.IsBanner); //首页每日晨会推荐
            Fields.Add("BannerPhoto", data.BannerPhoto); //每日晨会Banner
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolMorningMeet", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "SchoolMorningMeet", "update");
            var info = db.SchoolMorningMeet.FirstOrDefault(m => m.Id == data.Id);
            if (info != null)
            {
                info.Sort = function.ConvertDateTimeInt(data.CreateDate.Value) / 60;
                info.QueryCount = function.ConvertDateTimeInt(data.UpdateDate.Value) / 60;
                db.SaveChanges();
            }

            return "success";
        }

        #endregion

        #region 删除商学院每日晨会信息

        /// <summary>
        /// 删除商学院每日晨会信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMorningMeet", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolMorningMeet", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMorningMeet", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolMorningMeet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMorningMeet", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolMorningMeet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("SchoolMorningMeet", Sort, Id);

            AddSysLog(Id.ToString(), "SchoolMorningMeet", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.SchoolMorningMeet.Add(new SchoolMorningMeet()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "SchoolMorningMeet", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(SchoolMorningMeet data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Title", "1"); //标题
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("Lecturer", "1"); //主讲


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolMorningMeet", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "SchoolMorningMeet", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
